<?php


function theme_ejournal_page_ikaros($journal = NULL, $output = NULL) {
  drupal_set_html_head(ejournal_html_head());
  //drupal_set_message('You are using custom layout ikaros with this annying message - go to Administer::Edit journal to change the layout');
  return theme('page', $output ? $output : $journal);
}


function theme_ejournal_issue_reference_ikaros($journal, $issue, $full = TRUE) {  
  
  $output = "<div class=\"issue\">";
  if ($full) {
    $output .= l((ejournal_issue_reference($issue)), ejournal_path_set(array('action' => 'show', 'jid' => $issue->jid, 'iid' => $issue->iid)));
  } else {
    $path = ejournal_path_set(array('action' => 'show', 'jid' => $issue->jid, 'iid' => $issue->iid));
    $visible = isset($issue->number) ? t('No. ') . $issue->number : $issue->custom;
    $output .= l($visible, $path);
    $output .= "<br/>[ " . format_date($issue->date_published, 'custom', 'D. M. Y') . " ]";
  }
  $output .= "</div>\n";
  return $output;
}

function theme_ejournal_archive_ikaros($journal, $issues = NULL) {
  
  if (!$issues) { // if no issues, we will display whole archive
    $issues = _ejournal_journal_get_issues($journal);
    $full_archive = 1;
  }
  $output = "<div class=\"archive\">\n";  
  if ($full_archive && $journal->vid) {
    $output .= "<div class=\"section-form\"><h3>" . t('Display articles in section') . "</h3>\n";			
    $output .= drupal_get_form('theme_ejournal_section_form', $journal);
    $output .= "</div>";
  }
  $output .= "<div>";
  
  while ($issue = db_fetch_object($issues)) {
    if ($issue->volume != $old_volume) {
      $output .= "</div><div>";
      $output .= $full_archive ? ejournal_theme('ejournal_volume_reference', $journal, $issue) : ejournal_theme('ejournal_volume_reference', $journal, $issue);
      $old_volume = $issue->volume;
    }
    $output .= ejournal_theme('ejournal_issue_reference', $journal, $issue, FALSE);
    
    if (!$full_archive) {
      $articles = _ejournal_issue_get_articles($journal, $issue->iid);
      foreach ($articles as $article) {
        $output .= l($article->title, "node/$article->nid") . "<br/>";
      }
    }
  }
  $output .= "</div>";
  

  $output .= "</div>";
  drupal_set_title(t('%journal archive', array ('%journal' => $journal->title)));
  
  return ejournal_theme('ejournal_page', $journal, $output);
}

function theme_ejournalauthors_list_ikaros($journal, $vid, $char = NULL) {

  if (!$journal->author_vid) {
    return;
  }
  $vids = split(',', $journal->author_vid);
  foreach($vids as $vid) {
    
    $list = db_query("SELECT LEFT(name, 1) AS x FROM {term_data} WHERE vid='%d' GROUP BY x", $vid);
    while($c = db_fetch_object($list)) {
      $chars[] = ($char == $c->x) ? "<b>$c->x</b>" : l($c->x, ejournal_path_set(array("base" => "ejournal/authors", "jid" => $journal->jid, "action" => "list", "iid" => urlencode($c->x))));
    }
    if ($chars) {
      $alphabet = '<div id="pager">' . implode(' ', $chars) . '</div>';
    }
    
    
    //select term together with synonyms (if any) - group by name and show duplicates in "num"
    $char_limit = $char ? "AND td.name LIKE '" . db_escape_string($char) . "%'" : "";
    $sql = "(SELECT td.tid, td.name, COUNT(td.name) AS num FROM {term_data} td WHERE td.vid=$vid $char_limit GROUP BY td.name) UNION ALL (SELECT ts.tid, concat(td.name, ' --> ', ts.name) as name, 0 AS num FROM {term_synonym} td INNER JOIN {term_data} ts ON td.tid=ts.tid WHERE ts.vid=$vid $char_limit GROUP BY td.name) ORDER BY name";
    
    //print("SELECT ts.tid, ts.name, 0 AS num FROM {term_synonym} ts INNER JOIN {term_data} td ON ts.tid=td.tid WHERE td.vid=$vid $char_limit GROUP BY ts.name");
    //print ($sql);
    //$sql = "SELECT name, tid FROM {term_data} WHERE vid='".db_escape_string($vid)."' ORDER BY name";
    $sql_count = "SELECT count(td.name) FROM {term_data} td WHERE td.vid='" . db_escape_string($vid) . "'" . $char_limit;
    
    $result = pager_query($sql, 50, 0, $sql_count);
  
  
    $i = 0;
    $output .= $alphabet ? $alphabet : theme('pager', NULL, 50, 0);
    $output .= "<div class=\"ejournal-authors-list\">\n";
    while ($term = db_fetch_object($result)) {
      $path = ejournal_path_set(array("base" => "ejournal/authors", "jid" => $journal->jid, "action" => "show", "iid" => $term->tid));      
      if ($term->num) {
        if ($term->num > 1) { // two terms with identical name
          $output .= l("$term->name *", $path, NULL, urlencode("edit[multiple]") . "=1") . "<br/>\n";
        } else {
          $output .= l($term->name, $path, NULL, $url_type) . "<br/>\n";
        }
      } else {
        $output .= l($term->name, $path, NULL, $url_type) . "<br/>\n";
      }
      $i++;
      if ($i == 25) {
        $output .= "</div><div class=\"ejournal-authors-list\">";
        $i = 0;
      }
    }
    $output .= "</div>\n";
  
    $output .= theme('pager', NULL, 50, 0);
  }
  drupal_set_title(t('Browse authors of the journal %name', array (
    '%name' => $journal->title
  )));
  return ejournal_theme('ejournal_page', $journal, $output);

}

?>
